package T4Chart;

import java.sql.*;
import java.sql.Timestamp.*;
import java.util.*;
import T4Chart.*;
//---
//
public class Database {
    private static Database _instance = new Database() ;
    
    private Connection _cnx = null;
    private String _backend;
    
    private Database() {
    }
    
    public static Database getInstance() {
        return _instance ;
    }
    
    //---
    //   driver   : org.gjt.mm.mysql.Driver
    
    public void open(String backend, String host, String user,
                     char[] password , String dbname) {
        try {
            String driver;
            String str = "";
            String connectString;
            _backend = backend;
            Properties connProp = new Properties();
            connProp.put("user", user);
            char[] charArray = password;
            for (int i = 0; i < charArray.length; ++i)
                str += charArray[i];
            connProp.put("password", str);
            if (backend == "mysql") {
                driver = "org.gjt.mm.mysql.Driver";
                connectString = "jdbc:mysql://" + host + ":3306/" + dbname;            
                Class.forName(driver).newInstance();
                _cnx = DriverManager.getConnection(connectString, connProp);
            } else { // (_backend == "rdb")
                driver = "oracle.rdb.jdbc.rdbThin.Driver";
                connectString = "jdbc:rdbThin://" + host + ":1701/t4_rdb";
                Class.forName(driver).newInstance();
                _cnx = DriverManager.getConnection(connectString, connProp);
            }
            
        }
        catch ( ClassNotFoundException ecnf ) {
            ecnf.printStackTrace();
        }
        catch ( IllegalAccessException eia ) {
            eia.printStackTrace();
        }
        catch ( InstantiationException ei ) {
            ei.printStackTrace();
        }
        catch ( SQLException esql ) {
            esql.printStackTrace();
        }
        try {
            Statement stmt = _cnx.createStatement();
            String req;
            if (_backend == "mysql")
                req = "SET SESSION sql_mode='ansi'";
            else // (_backend == "rdb")
                req = "set schema '" + dbname + "'";
            stmt.execute(req);
            stmt.close();
        }
        catch ( SQLException esql ) {
            esql.printStackTrace();
        }
  }
    
    public void close() {
        if (_cnx != null) {
            try {
                _cnx.close();
                _cnx = null ;
            }
            catch ( SQLException esql ) {
                esql.printStackTrace();
            }
        }
    }
    
    public Vector getTables(String nodeName) {
        Statement stmt = null;
        Statement stmt2 = null;
        ResultSet rs = null;
        Vector v = null;
        
        if ( _cnx == null ) {
            throw new RuntimeException("You are not connected to the database");
        }
        
        try {
            stmt = _cnx.createStatement();
            stmt2 = _cnx.createStatement();
            ResultSet rsb;
            v = new Vector();
            stmt = _cnx.createStatement();
            rs = stmt.executeQuery("select distinct table_name from repository order by 1");
            while (rs.next()) {
                String tableName = rs.getString(1).trim();
                String req;
                req = "select 1 from node, " + tableName +
                " where node.node_name = '" + nodeName +
                "' and node.node_id = " + tableName + ".node_id";
                rsb = stmt2.executeQuery(req);
                if (rsb.next()) v.add(tableName);
                rsb.close();
            }
            stmt2.close();
            stmt.close();
            rs.close();
        }
        catch (SQLException esql) {
            esql.printStackTrace();
        }
        return v;
    }
    
    //---
    //
    public Vector getNodes() {
        Statement stmt = null;
        ResultSet rs = null;
        Vector v = null;
        
        if (_cnx == null) {
            throw new RuntimeException("You are not connected to the database");
        }
        
        try {
            v = new Vector();
            stmt = _cnx.createStatement();
            rs = stmt.executeQuery( "select node_name from node order by node_name");
            while (rs.next()) {
                String nodeName = rs.getString(1).trim();
                v.add(nodeName);
            }
            rs.close();
            stmt.close();
        }
        catch (SQLException esql) {
            esql.printStackTrace();
        }
        return v;
    }
    
    //---
    //
    public Vector getColumns(String tableName) {
        PreparedStatement pstmt = null;
        ResultSet rs   = null ;
        Vector v = null;
        
        if ( _cnx == null ) {
            throw new RuntimeException("You are not connected to the database");
        }
        
        try {
            v = new Vector();
            String req = "select item_name from repository where table_name = ? order by item_id";
            pstmt = _cnx.prepareStatement(req);
            pstmt.setString(1, tableName);
            rs   = pstmt.executeQuery();
            while (rs.next()) {
                String colName = rs.getString(1).trim();
                v.add((Object)colName);
            }
            rs.close();
            pstmt.close();
        }
        catch (SQLException esql) {
            esql.printStackTrace();
        }
        return v;
    }
    
    //---
    //
    public Vector getDatesRange(String nodeName, String tableName, String tsColName) {
        Statement stmt = null;
        ResultSet rs   = null;
        Vector v = null;
        
        if (_cnx == null) {
            throw new RuntimeException("You are not connected to the database");
        }
        
        try {
            stmt = _cnx.createStatement();
            String s;
            if (_backend == "mysql") {
                s = "select date_format(min(" + tsColName + "), '%Y-%m-%d %H:%i:%s'),date_format(max(" +
                    tsColName + "),'%Y-%m-%d %H:%i:%s')" +
                    " from node," + tableName + "  where node.node_name = '" +
                    nodeName + "' and node.node_id = " + tableName + ".node_id";
                s = "select min(" + tsColName + "), max(" + tsColName + ") from node," +
                     tableName + "  where node.node_name = '" + nodeName + 
                     "' and node.node_id = " + tableName + ".node_id";
            } else { // (_backend == "rdb")
                s = "select min(" + tsColName + "), max(" + tsColName + ") from node," +
                     tableName + "  where node.node_name = '" + nodeName + 
                     "' and node.node_id = " + tableName + ".node_id";
            }
//           System.err.println(s);
            rs = stmt.executeQuery(s);
            v = new Vector(2);
            rs.next();
            Timestamp ts;
            ts = rs.getTimestamp(1);
            ts.setSeconds(0);
            ts.setNanos(0);
            v.add(ts);
            ts = rs.getTimestamp(2);
            ts.setSeconds(0);
            ts.setNanos(0);
            v.add(ts);
            rs.close();
            stmt.close();
        }
        catch (SQLException esql) {
            esql.printStackTrace();
        }
        return v;
    }
    
    //---
    // 
    public SqlIterator getItemValues(String nodeName, String tableName, String colName, 
                                     String tsColName, String startDate, String endDate) {
        PreparedStatement pstmt = null;
        ResultSet rs   = null ;
        
        if ( _cnx == null ) {
            throw new RuntimeException("You are not connected to the database");
        }
        try {
            String s;
            s = "select column_name from repository where table_name = ? and item_name = ?";
            pstmt = _cnx.prepareStatement(s);
            // set parameter value
            pstmt.setString(1, tableName);
            pstmt.setString(2, colName);
            // System.err.println(pstmt);
            rs   = pstmt.executeQuery();
            rs.next();
            colName = rs.getString(1).trim();
            rs.close();
            pstmt.close();
            s = "select " + tsColName + "," + colName + " from node," +
                tableName + "  where node.node_name = ?" +
                " and node.node_id = " + tableName + ".node_id and " + 
                tableName + "." + tsColName +
                " >= ? and " + tableName + "." + tsColName + 
                " <= ? order by 1";
            // System.err.println(s);
            pstmt = _cnx.prepareStatement(s);
            // set parameter value
            pstmt.setString(1, nodeName);
            Timestamp ts;
            ts = Timestamp.valueOf(startDate);
            pstmt.setTimestamp(2, ts);
            ts = Timestamp.valueOf(endDate);
            pstmt.setTimestamp(3, ts);
            // System.err.println(pstmt);
            rs   = pstmt.executeQuery();
        }
        catch (SQLException esql) {
            esql.printStackTrace();
        }
        
        return new SqlItemValuesIterator(pstmt, rs) ;
    }
    
    //---
    //    
    private class SqlItemValuesIterator extends SqlIterator {
        public SqlItemValuesIterator(PreparedStatement stmt, ResultSet rs) {
            super(stmt, rs);
        }
        
        Object createObjectFromRow(ResultSet resultset) throws Exception {
            Vector v = new Vector(2);
            Timestamp ts;
            ts = resultset.getTimestamp(1);
            ts.setSeconds(0);
            ts.setNanos(0);
            v.add(ts);
            v.add(new Double(resultset.getDouble(2)));
            return v;
        }
    }
    
}